
-- Locale
local L_CRIT = " ".. _G["CRIT_ABBR"]
local L_SPEED = " ".. _G["SPEED"]
local L_AP = " ".. _G["ATTACK_POWER_TOOLTIP"]
local L_HASTE = " ".. _G["STAT_HASTE"]

-- Objects Creation
local RS = CreateFrame("Frame", "StatBlock_RangedStats")
local LDB = LibStub("LibDataBroker-1.1")
RS.AP = LDB:NewDataObject("Ranged_AP", {type = "data source", text = "0"..L_AP, value = "0", suffix = L_AP})
RS.Crit = LDB:NewDataObject("Ranged_Crit", {type = "data source", text = "0%"..L_CRIT, value = "0%", suffix = L_CRIT})
RS.Speed = LDB:NewDataObject("Ranged_Speed", {type = "data source", text = "0.00"..L_SPEED, value = "0.00", suffix = L_SPEED})
RS.Haste = LDB:NewDataObject("Ranged_Haste", {type = "data source", text = "0%"..L_HASTE, value = "0%", suffix = L_HASTE})

-- Upvalues
local format = string.format
local UnitRangedAttackPower = UnitRangedAttackPower
local UnitRangedDamage = UnitRangedDamage
local GetCombatRatingBonus = GetCombatRatingBonus
local GetRangedCritChance = GetRangedCritChance
local GetRangedHaste = GetRangedHaste
local two_fp = "%.2f%%"

-- Events
RS:RegisterEvent("UNIT_MODEL_CHANGED")
RS:RegisterEvent("PLAYER_LEVEL_UP")
RS:RegisterEvent("UNIT_AURA")
RS:RegisterEvent("PLAYER_LOGIN")

-- Calculations
RS:SetScript("OnEvent", function(self, _, unit)
	if unit and unit ~= "player" then return end

	local base, pos, neg = UnitRangedAttackPower"player"
	local ap = format("%d", base + pos + neg)
	self.AP.text = ap..L_AP
	self.AP.value = ap

	local crit = format(two_fp, GetRangedCritChance())
	self.Crit.text = crit..L_CRIT
	self.Crit.value = crit

	local haste = format(two_fp, GetRangedHaste())
	self.Haste.text = haste..L_HASTE
	self.Haste.value = haste

	local speed = format("%.2f", UnitRangedDamage"player")
	self.Speed.text = speed..L_SPEED
	self.Speed.value = speed
end)

